// PEFile.h: interface for the CPEFile class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PEFILE_H__D2AEFEAE_64CF_11D6_8219_C39BEFFBD801__INCLUDED_)
#define AFX_PEFILE_H__D2AEFEAE_64CF_11D6_8219_C39BEFFBD801__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

typedef struct
{
     WORD  Signature;         //'MZ'
     WORD  PartPag;           //   
     WORD  PageCnt;           //  (+)  512-
     WORD  ReloCnt;           //   Relocation Table
     WORD  HdrSize;           //   16-
     WORD  MinMemory;         //  
     WORD  MaxMemory;         //  
     WORD  ReloSS;            //  ( RootS)
     WORD  ExeSP;             // 
     WORD  ChkSum;            // 
     WORD  ExeIP;             // 
     WORD  ReloCS;            //  ( RootS)
     WORD  TablOff;           //   1-  Relocation Table
     WORD  Overlay;           // 
     BYTE  Reserved[32];      //
     DWORD OffsetToPEHeader;  //
} DOSHeader;



typedef struct
{
	 BYTE ObjectName[8];
	 DWORD VirtualSize;
	 DWORD SectionRVA;
	 DWORD PhysicalSize;
	 DWORD PhysicalOffset;
	 BYTE Reserved[10];
	 DWORD ObjectFlags;
}    ObjectEntry;

typedef struct
{
     DWORD SignatureBytes;
	 WORD  CPUType;
	 WORD  NumOfSections;
	 DWORD TimeDateStamp;
	 DWORD PointerToCOFF;
	 DWORD COFFTableSize;
	 WORD  NTHeaderSize;
	 WORD  Flags;
	 WORD  Magic;
	 BYTE  LinkMajor;
	 BYTE  LinkMinor;
	 DWORD SizeOfCode;
	 DWORD SizeOfInitData;
	 DWORD SizeOfUnInitData;
	 DWORD EntryPointRVA;
	 DWORD BaseOfCode;
	 DWORD BaseOfData;
	 DWORD ImageBase;
	 DWORD ObjectAlign;
	 DWORD FileAlign;
	 WORD  OSMajor;
	 WORD  OSMinor;
	 WORD  USERMajor;
	 WORD  USERMinor;
	 WORD  SubSysMajor;
	 WORD  SubSysMinor;
	 DWORD Reserved;
	 DWORD ImageSize;
	 DWORD HeaderSize;
	 DWORD FileChecksum;
	 WORD  SubSystem;
	 WORD  DLLFlags;
	 DWORD StackReserveSize;
	 DWORD StackCommitSize;
	 DWORD HeapReserveSize;
	 DWORD HeapCommitSize;
	 DWORD LoaderFlags;
	 DWORD NumOfRVAandSizes;
	 DWORD ExportTableRVA;
	 DWORD ExportDataSize;
	 DWORD ImportTableRVA;
	 DWORD ImportDataSize;
	 DWORD ResourceTableRVA;
	 DWORD ResourceDataSize;
	 DWORD ExceptionTableRVA;
	 DWORD ExceptionDataSize;
	 DWORD SecurityTableRVA;
	 DWORD SecurityDataSize;
	 DWORD FixUpTableRVA;
	 DWORD FixUpDataSize;
	 DWORD DebugTableRVA;
	 DWORD DebugDataSize;
	 DWORD ImageDescriptionRVA;
	 DWORD DescriptionDataSize;
	 DWORD MachineSpecificRVA;
	 DWORD MachnineDataSize;
	 DWORD TLSRVA;
	 DWORD TLSDataSize;
	 DWORD LoadConfigRVA;
	 DWORD LoadConfigDataSize;
	 BYTE  Reserved01[8];
	 DWORD IATRVA;
	 DWORD IATDataSize;
	 BYTE  Reserved02[8];
	 BYTE  Reserved03[8];
	 BYTE  Reserved04[8];
} PEHeader;


class CPEFile  
{
public:
	virtual VOID WriteDOSHeader(VOID);
	virtual UINT ReadDOSHeader(VOID);
	virtual BOOL CheckAccess(VOID);
	virtual BOOL IsPEFile(VOID);
	CPEFile();
	virtual ~CPEFile();
	virtual UINT ReadObjectEntry(VOID);
	virtual VOID WriteObjectEntry(VOID);
	virtual LONG SeekToObjectEntry(VOID);
	virtual LONG SeekToPEHeader(VOID);
	virtual UINT ReadPEHeader(VOID);
	virtual VOID WritePEHeader(VOID);
	virtual VOID Close(VOID);
	virtual BOOL Open(LPCTSTR szPEFile, BOOL ReadOnly = FALSE);

	DOSHeader            DOSHdr;
	PEHeader             PEHdr;
	ObjectEntry          ObjEntry;

	CStdioFile m_hPEFile;
protected:
	DWORD dwOffsetToPEhdr;
};

#endif // !defined(AFX_PEFILE_H__D2AEFEAE_64CF_11D6_8219_C39BEFFBD801__INCLUDED_)
